{{- $tls := fromYaml ( include "admission-controller.gen-certs" . ) }}
---
apiVersion: admissionregistration.k8s.io/v1
kind: MutatingWebhookConfiguration
metadata:
  name: {{ include "admission-controller.fullname"  .}}
  labels:
    {{- include "admission-controller.labels" . | nindent 4 }}
webhooks:
  - name: {{ include "admission-controller.service.fullname" . }}
    failurePolicy: Ignore
    timeoutSeconds: 10
    admissionReviewVersions: ["v1", "v1beta1"]
    sideEffects: None
    clientConfig:
      service:
        name: {{ include "admission-controller.fullname" . }} 
        namespace: {{ .Release.Namespace }}
        path: /mutate/pvcs
        port: 8443
      caBundle: {{ $tls.caCert | quote }}
    rules:
      - apiGroups: [""]
        resources:
          - persistentvolumeclaims
        apiVersions:
          - "*"
        operations:
          - CREATE
---
apiVersion: v1
kind: Secret
metadata:
  name: {{ include "admission-controller.fullname" . }}-tls
  labels:
    {{- include "admission-controller.labels" . | nindent 4 }}
type: kubernetes.io/tls
data:
  tls.crt: {{ $tls.clientCert }}
  tls.key: {{ $tls.clientKey }}
